  {

    Module     : INDTYPE.INC

    Facility   : INDEX.PAS V2.1

    Author     : H.J.C. Otten

    Purpose    : definition of types

    Creation   :  5-jan-1989

    Update     : 18-aug-1989 
                    - date info included
                    - changed presentation of size and totalsize and count
    Data       : 
                 filename
                 fileptr
                 filenode
                 diskptr
                 disknode

    Procedures : n.a.

  }

  filename = string20 ;

  filespec_type = packed array[1..length_filespec] of char ;

  fileptr  = ^filenode ;

  filenode = record
               size     : integer ;  { size in K }
               date1,
               date2    : byte    ;  { hold MS-DOS encoded date info }
               nextfile : fileptr ;
               case boolean of
                 true  : ( 
                           filename : packed array[1..length_filename] of char ;
                           filetype : packed array[1..length_filetype] of char ;
                           diskname : packed array[1..length_diskname] of char ;
                         ) ;
                 false : ( filespec : filespec_type ) ;
             end;

  diskptr = ^disknode ;

  disknode = record
               nextdisk  : diskptr  ;
               diskname  : string3  ;
               diskdescr : string40 ;
               totalsize : integer  ;
               count     : integer  ;
             end ;
										
{ end INDTYPE.INC }
