[inherit ('sys$library:starlet')] 
program Index (input,output) ;

{ Index of directory maintenance program

  H.J.C. Otten
  V1.0 april     1987
  V1.1 september 1988
  V2.0 januari   1989
  V2.1 augustus  1989

  This program is donated to the public domain.
  You may freely distribute the code of this program
  to your friends.
  No commercial use of this software shall be made
  without written prior permission by the author


    Module     : INDVMSE4.PAS

    Facility   : INDEX V2.1

    Author     : H.J.C. Otten

    Purpose    : main program

    Creation   : 05-jan-1989

    Update     : 16-feb-1989
    Update     : 29-aug-1989 V2.1

    Data       : 

    Procedures : n.a.

    Modules    :
                 INDCONST .INC  constants
                 INDMSG   .INC  messages, language dependent
                 INDTYPE  .INC  type definitions
                 INDTYPxxx.INC  operating system/language type definitions
                 INDVAR   .INC  global variable declarations
                 INDxxx   .INC  operating system dependent  procedures/functions
                 INDMAIN  .INC  initialization code
                 INDEX    .INC  general procedures/functions
                 INDDIR   .INC  disk directory procedures/functions 
                 INDPRNT  .INC  print related procedures/functions
                 INDSRCH  .INC  search procedures/functions
                 INDFILE  .INC  index file procedures/functions
   
                   xxx = operating system specification
 
                            xxx = VMS for VAX/VMS with VAX Pascal
                            xxx = CPM for CP/M 
                            xxx = MS  for MS-DOS
                            xxx = MSX for MSX
  }


const

  vms   = true ;
  msdos = false ;
  cpm   = false ;
  msx   = false  ;
  %include 'indconst.inc'

  { language and terminal dependent include file }
  %include 'indmsge4.inc'

type

  %include 'indtypvm.inc'
  %include 'indtype.inc'


var

  montht : array[1..12] of packed array[1..3] of char ;
  %include 'indvar.inc'

  %include 'indvms.inc'

  %include 'index.inc'
  %include 'inddir.inc'

  %include 'indsrch.inc'
  %include 'indfile.inc'
  %include 'indprnt.inc'

  %include 'INDMAIN.inc'

begin

  montht[ 1] := 'Jan' ;
  montht[ 2] := 'Feb' ;
  montht[ 3] := 'Mar' ;
  montht[ 4] := 'Apr' ;
  montht[ 5] := 'May' ;
  montht[ 6] := 'Jun' ;
  montht[ 7] := 'Jul' ;
  montht[ 8] := 'Aug' ;
  montht[ 9] := 'Sep' ;
  montht[10] := 'Oct' ;
  montht[11] := 'Nov' ;
  montht[12] := 'Dec' ;

  { only for VMS }
  rstatus := $ASSIGN('TT:',termchan,,) ;

  Init_data ;
  Check_parameter ;
  MainLoop ;

end.
